
Released version 699,  February 20, 2008

  (modification) Change the default font of JunTextEditor for Mac
  OS X from 'Osaka Mono' to 'Monospaced'.

  (bug fix) Fixed a bug of JunFileList.  It threw an exception
  when selecting a directory without a permission.

  (bug fix) Fixed a bug of JunFileRequester related to a virtual
  root.

  (modification) Two sample objects of JunSampleTriangle are
  defined.

  (modification) Some more methods for transformations are added
  in Jun2dCircle, Jun3dCircle, and Jun2dPolygon.

  (incompatibility) JunURL is moved to a new package
  'jp.co.sra.jun.goodies.tips'.

  (new feature) JunAbstractObject is introduced as a part of Jun
  class library framework in Jun697.

  (new feature) JunAbstractModel is introduced as a part of Jun
  MVC framework in Jun699.

  (modification) JunMoviePlayer is updated to Jun696.  The method
  'releaseMovie' is defined to be called from 'release'.

  (modification) JunLine and its subclasses are updated to Jun697. 
  The method 'angleWithLine_(JunLine)' is defined as an abstract
  method in JunLine.

  (modification) JunImageDisplayModel is updated to Jun696.

  (modification) JunCursors is updated to Jun699.

  (modification) Jun2dBoundingBox and Jun3dBoundingBox are
  updated to Jun693.  Some utility methods are added.

  (bug fix) Fixed a bug of the inverse calculation by Gauss
  Elimination in JunDoubleMatrix.  This bug is fixed in Jun758
  for Smalltalk.

  (modification) The default width of the buttons on
  JunFileRequesterDialogViewAwt and
  JunFileRequesterDialogViewSwing are changed to be wider since a
  shape of a button in Mac OS X Leopard is difference from the
  one in Tiger.

  (modification) JunPopUpDialogViewAwt and
  JunPopUpDialogViewSwing use a new default dialog creation
  method defined in StSimpleDialogView which can specify a parent
  component and a flag whether the dialog should be decorated or
  not.

  (modification) JunDXFParser ignores DICTIONARY section instead
  of throwing exception.

  (modification) JunGifAnimationStream is now able to read
  optimized images.

  (modification) The default font specification (Osaka) on Mac is
  removed.  When apple.awt.graphics.UseQuartz is true, Leopard
  does not show 'Osaka' properly and Tiger now shows 'Dialog'
  properly.

Released version 695,  November 15, 2007

  (bug fix) Calling dispose() to Dialog in JunProgress may cause
  a deadlock.

  (bug fix) JunControlUtility#WaitUntilTimeMillis_(long)
  sometimes return before the specified time.

  (modification) JunOpenGLDisplayController is updated to Jun696.
    - A preference 'noControl' of JunOpenGLDisplayModel is
      effective.
    - Modified to use Timer instead of Thread for rotating.

  (modification) JunOpenGL3dModel and JunOpenGLDisplayModel are
  updated to Jun696.
    - A view without any widgets can be created.
    - The movement vector can be specified from the model.
    - The projection table can be copied/pasted.

  (modification) JunAttributeTable is updated to Jun696. 
  JunOpenGL3dModel can copy/paste its projection table.

  (modification) JunCartoonMovie is updated to Jun697.
    - Can open/save a GIF animation.
    - Modified to use Timer instead of Thread for playing.
    - Cache the images in the views for painting.

  (modification) JunImagesToMovie is updated to Jun693.

  (new feature) JunImagesToGifAnimation is implemented.  It
  converts multiple images to a GIF animation.

  (new feature) JunGifAnimationStream is implemented.  It enables
  reading and writing a GIF animation.

  (new feature) JunSraGifImageStream is implemented.  It enables
  writing a GIF image.

  (modification) Jun2dTrianlge, Jun3dTriangle and JunNurbsCurve
  are updated to Jun692.  A method to convert an array of lines
  is implemented.

  (modification) JunGeometry and its subclasses are updated to
  Jun691.  Some methods to convert a geometry into
  JunOpenGL3dPolylines are added.

  (modification) JunOpenGL3dObject and
  JunOpenGL3dTypicalObjectsBall are updated to Jun692. 
  ColorBalls are added as typical objects.

  (modification) JunOpenGL3dObject and its subclasses are updated
  to Jun691.  Some testing methods are added.

  (modification) JunGeometry is updated to Jun679.  Some utility
  methods related to hemisphere are implemented.

  (modification) JunFileList is updated to Jun690.  An action for
  the selection can be specified with the select block.

  (modification) JunApplicationModel is updated to Jun689.  The
  'closeTogether' method may or may not be executed with
  alt/shift key modifier.

  (modification) JunFileRequester is updated to Jun686.

  (modification) JunOpenGL3dModel is updated to Jun685.

  (modification) JunOpenGLDisplayModel is updated to Jun684.  The
  wheel action in the top-center box is changed.

Released version 683,  September 18, 2007

  (modification) Refines mousePressed/Released event handling in
  JunAbstractController.

  (modification) The default shading is changed from 'flat' to
  'smooth'.

  (new feature) JunOpenGL3dObject can calculate its vertex
  normal vectors by specifying a smoothing angle, and a smoothing
  angle can be specified from a view finder.

  (new feature) JOGL(https://jogl.dev.java.net/) can be used as
  an OpenGL binding in addition to JunGL.  JunOpenGLInterface is
  defined as an abstract class of the interfaces for both JunGL
  and JOGL.  JunOpenGLDrawable is an interface to represent a 3D
  drawable component. 
  JOGLCanvas/JOGLJPanel/JunGLCanvas/JunGLJPanel are the classes
  which implement JunOpenGLDrawable.  You can choose one of them
  as a system default drawable from the launcher menu.

  (incompatibility) According to the JOGL enhancement,
  JunOpenGL3dViewAwt/JunOpenGL3dViewSwing are changed to the
  subclasses of JunAbstractViewPanel/JunAbstractViewJPanel
  respectively.

  (incompatibility) According to the JOGL enhancement, the
  rendering mode settings are not effective anymore.

  (new feature) HashEqualityDictionary and HashEqualitySet are
  defined as internal classes of JunGeometry.  They are
  subclasses of HashMap/HashSet in which the key is an instance
  of JunGeometry and compares with the 'equal_()' methods instead
  of the 'equals()' method.

  (modification) JunSpiroDesign is updated to Jun681.

  (modification) JunGeometry and its subclasses are updated to
  Jun683.

  (modification) JunImageUtility and JunStringUtility are updated
  to Jun681.

  (modification) JunDXFParser is updated to Jun678.

  (modification) JunApplicationModel is updated to Jun681.

  (modification) JunMultiMediaNavigator is updated to Jun674.

  (modification) JunSorobanModel is updated to Jun674.

  (modification) JunOpenGL3dObject and its subclasses are updated
  to Jun683.  A mobius is defined as a typical object.

  (modification) The definitions of typical objects in
  JunOpenGL3dObject are too large, so separated into classes and
  stored in the package 'jp.co.sra.jun.opengl.objects.typical'.

  (new feature) JunRevisionManager is a class for managing
  revisions of values.

Released version 668a,  July 11, 2007

  (bug fix) In GLjJCanvas, setting the request flags for moved or
  resized should be done in the 'setBounds()' method.  Setting
  flags by a component listener may be done after the repaint in
  JDK1.5.

Released version 668,  July 6, 2007

  (new feature) Jun2dPolyline/Jun3dPolyline are updated to Jun682. 
  The method 'subdivideAsSpline()' creates a spline from a
  polyline.

  (new feature) The package 'jp.co.sra.jun.geometry.solid'
  contains classes which correspond to some typical solid.

  (new feature) The package 'jp.co.sra.jun.geometry.boxtree'
  contains classes to get a boundary of an object with
  rectangles/boxes.

  (modification) StSortedCollection is deprecated now and
  replaced with TreeSet/TreeMap or sorting methods of
  Arrays/Collections.

  (bug fix) Fixed a bug of JunNibChoiceWithColorDialog.

  (new feature) JunFormCreation is a class for creating forms (or
  shapes).

Released version 662a,  June 21, 2007

  (new feature) JunDiscreteFourierTransformation is a class to
  compute the discrete Fourier transform.

  (new feature) JunFormTriangulation1 and JunFormTriangulation3
  are implemented.  They are classes for triangulation with
  different algorithms.

  (bug fix) Fixed a bug of Jun2dDelaunaryProcessor.

  (new feature) Jun2dTriangles/Jun3dTriangles are defined for
  handling a collection of triangles.

  (modification) More comparing methods are defined in
  Jun2dPoint/Jun3dPoint.

  (new feature) Jun2dBoundingBalls/Jun3dBoundingBalls are the
  classes which calculate a boundary of an object with
  circles/balls.

  (incompatibility) JunBoundingObjects, JunBoundingBoxes, and
  their subclasses are moved to the package
  'jp.co.sra.jun.geometry.pluralities'.

  (modification) Some geometry related classes, such as JunPlane,
  JunPolygon, JunLine, JunPoint, and JunCircle, are updated to
  Jun667.

Released version 662,  May 24, 2007

  (modification) JunDelaunay2dDiagram is updated to Jun662. 
  Methods to get a convex hull and a minimal enclosing circle are
  added.

  (modification) JunOpenGL3dObject is updated to Jun665.  More
  typical arrow objects are added.

  (modification) JunOpenGL3dTransformedObject is updated to
  Jun656.  The internally used object is cached for efficiency.

  (modification) JunGeometry and its subclasses are updated to
  Jun658.  Some methods for converting to planes/triangles are
  added.

  (new feature) Discrete wavelet transforms are implemented. 
  JunDiscreteWavelet1dTransformation is a class for one
  dimensional data and JunDiscreteWavelet2dTransformation is for
  two dimension.

  (modification) JunMatrix/JunDoubleMatrix are updated to Jun660.

Released version 655,  May 1, 2007

  (new feature) JunPlane, Jun3dLine, and Jun2dLine are updated to
  Jun655.  The new method 'reflectingLineWithLine_()' of JunPlane
  is for getting a reflecting line.

  (modification) JunOpenGL3dObject is updated to Jun655.  More
  typical objects related to arrows are defined.

  (modification) JunOpenGL3dModel is updated to Jun650.  A
  preference table is introduced to set/get preferences.

  (new feature) JunStopwatch is a class that implements a
  stopwatch feature.

  (modification) A new utility method, NextMillisecondClockvalue(),
  is added to JunControlUtility

  (modification) More typical objects (especially related to
  chemical) are defined in JunOpenGL3dObject.

  (modification) JunStringUtility is updated to Jun648.  More
  utility methods are added.

  (modification) JunSimpleSliderModel, JunTrackSliderModel, and
  JunTrackerModel are updated to Jun651.  The default window
  title is defined.

  (modification) JunSoundMeterModel is updated to Jun651.  The
  default window title is defined.

  (modification) JunParameterModel and JunParametersModel are
  updated to Jun651.  The default window titles are defined.

  (modification) JunMultiMediaExtraModel is updated to Jun648.

  (modification) JunCursors is updated to Jun651.  Mouse cursors
  are added.

  (modification) JunCursorAnimator is updated to Jun651.  The
  stopwatch cursors are defined.

  (modification) JunColorBarDialog is updated to Jun651.  The
  default window title is defined.

  (modification) JunApplicationModel is updated to Jun651.  The
  default window title is defined.

  (new feature) JunStereoLevelMeter is a class which has two
  JunLevelGaugeMeter's for left/right values.

  (new feature) JunLevelGaugeMeter is a class which combines some
  JunLevelGaugeModel to show gauges as a meter.

  (new feature) JunLevelGaugeModel is a class for visualizing a
  level gauge with a value of a range and hill/dale/average
  values.

  (bug fix) Fixed a bug of JunGraphicViewSwing related to
  resizing and scrolling.

Released version 646,  March 27, 2007

  (bug fix) Fixed a bug of JunFileNavigator.  Clicking a file on
  the left list didn't update the left list.

  (modification) JunMultiMediaNavigator is updated to Jun656. 
  Some 3D files (lst or wrl) can be shown.

  (modification) DefaultBodyExtension() is defined in JunSystem.

  (modification) JunOpaqueImageIcons is updated to Jun653.  The
  body icon is added.

  (modification) JunFileList is updated to Jun654.

  (modification) JunThumbWheel is updated to Jun651.  It now can
  handle mouse wheel actions.

  (modification) More typical objects defined in JunOpenGL3dObject.

  (modification) Shows a banner when executing JunLauncher.

Released version 642,  March 6, 2007

  (modification) JunApplicationModel is updated to Jun642.  An
  utility method to get nine boxes of the specified area is
  implemented.

  (new feature) JunOpenGLDisplayController implements
  MouseWheelListener and JunOpenGLDisplayModel can handle mouse
  wheel actions to manipulate 3D object.

  (modification) Refactoring on JunBorderGenerator.  Unnecessary
  classes are removed.

  (modification) JunOpenGL3dCompoundObject is updated to Jun641.

  (modification) JunOpenGLTexture is updated to Jun641.  Utility
  methods to create a texture from a string while specifying an
  alignment are implemented.

  (modification) JunOpenGL3dModel, JunOpenGLDisplayModel,
  JunOpenGLShowModel, JunOpenGLFluxModel,
  JunOpenGLEmbeddedDisplayModel and JunTerrainDisplayModel are
  updated to Jun642.  Open a new window next to the already
  opened window when spawing.

  (modification) The package 'jp.co.sra.jun.goodies.catalog.*' is
  updated to Jun640.  More images/movies can be handled.

  (new feature) JunChart* can show its labels, not only with
  textures, but also with scalable 3D objects.

  (bug fix) Fixed more a byte order problem of the QuickTime
  interface on an Intel Mac.

  (modification) The extension 'mp4' is included in the default
  movie extensions.

  (modificatoin) More transforming methods are implemented in
  Jun2dBoundingBox and Jun3dBoundingBox.

  (modification) JunFontModel is updated to Jun642.

  (modification) JunOpenGL3dObject is updated to Jun642.

  (bug fix) Fixed a bug of JunOpenGLFluxMutableObject.  Did not
  load transformations from lisp list.

Released version 637,  December 13, 2006

  (bug fix) Fixed a byte order problem of the QuickTime interface
  on an Intel Mac.

  (modification) JunImageAdjuster is updated to Jun632.  Add more
  utility methods for adjusting an image.

  (modification) JunProgress is modified not to use a modal
  dialog.  It was using modal dialog for not blocking the event
  dispatch thread, but it might cause a problem if a task was
  finished before opening a dialog.  As in Smalltalk version,
  open a dialog as modeless and bring the dialog to front when
  updating.

  (modification) JunFileDialog#RequestNewFilename() is deprecated,
  use RequestNewFile() instead.

  (bug fix) Fixed a bug of Jun2dPoint/Jun3dPoint.  The argument
  of the comparing methods can be null.

  (bug fix) JunImageToAscii did not work correctly. It is
  reimplemented and updated to Jun668.

  (modification) JunImagesToMovie is updated to Jun637.  The size
  of adding images are adjustable.

  (modification) JunOpenGLDisplayModel is updated to Jun636.  The
  method 'newModel()' is defined in JunApplicationModel.

  (new feature) JunFileRequesterDialog is a replacement of
  JunFileDialog which uses JunFileNavigator instead of
  JunFileModel.  All use of JunFileDialog in "Jun for Java" is
  replaced with JunFileRequesterDialog.

  (new feature) JunMultiMediaNavigator is a replacement of
  JunMultiMediaViewer which uses JunFileNavigator instead of
  JunFileModel.

  (new feature) JunFileNavigator is a class to browse your file
  system with three columns of a list of files.  The center
  column shows your current selection and its siblings.  The left
  column shows the parent directory of your current selection and
  its siblings.  The left column shows either children of your
  current selection (if it is a directory) or a detailed
  information about your current selection (if it is a file).

  (modification) JunTextEditor can be specified either it is
  editable or not.

  (modification) JunStringUtility is updated to Jun639.  Utility
  methods to write a tag notation are added.

Released version 633a,  November 15, 2006

  (bug fix) Fixed a bug of Jun2dPoint.  Calculating a center
  point with another point was incorrect.

  (bug fix) Fixed a bug of JunOpenGLProjector.  Setting a sight
  point might not be effected.

Released version 633,  November 10, 2006

  (modification) JunVornoi2dDigram and JunDelaunay2dDiagram are
  updated to Jun633.

  (modification) JunChartAbstract, JunChartCombination, and
  JunTerrainEditModel are updated to Jun630.  The method
  flushDisplayObject() is now defined in JunOpenGL3dModel

  (modification) JunOpenGL3dGraph is updated to Jun630

  (modification) JunPlotter is updated to Jun629

  (modification) JunOpenGLPlotter is updated to Jun629. 
  Refactoring and controlling the time.

  (modification) JunOpenGL3dGraphTestExamples is updated to
  Jun629.  Controls the number of frames per second.

  (modification) JunLauncher is updated to Jun629.  Plotter 2D/3D
  menu items are added to tools menu.

  (modification) JunGaugeViewAwt/Swing are updated to Jun629. 
  The default bounds is changed.

  (modification) JunFileDialog Updated to Jun629.  Defines a
  utility method for requesting a file.

  (modification) JunChartAbstract and its subclasses are updated
  to Jun629.  The default background color of a label is now
  white.

  (modification) JunForm2dRegion is update to Jun697.  It now
  supports a feature for thinning (or skeletonization).

  (modification) JunAngle and Jun3dLine are updated to Jun628. 
  Defines a transforming method.

  (bug fix) Fixed a bug of JunImageProcessor. An
  OutOfIndexException was thrown.

  (modification) JunPenGeometry, JunUNION, JunVoronoi2dObject,
  and JunVrmlGenerator20/97 are updated to Jun627.  Uses
  JunGeometry.ACCURACY.

  (modification) JunOpenGL3dObject is updated to Jun627.  Two
  more viewing utility methods are defined.

  (modification) Jun3dTriangleTestExamples is updated to Jun627. 
  Uses JunPointsOnPlane instead of JunPointSorter.

  (new feature) JunPointsOnPlane is a utility class for handling
  points on a plane.

  (modification) JunApplicationModel now has a feature to be
  specified a collection of StApplicationModel that are supposed
  to be closed together.

  (modification) JunColorChoiceController is updated to Jun624. 
  Uses JunTextInputField for input values.

  (modification) JunControlUtility now has more methods for
  holding.

  (new feature) JunPopUpDialog and JunTextInputField are
  implemented.

  (modification) JunImageDisplayModel now has a method to show an
  image with a label on a window title bar.

  (new feature) JunOpenGLStereoDisplayModel is a class to show
  two 3D views for stereoscope.

  (new feature) JunSensorUtility is a class for checking input
  events.

  (modification) JunOpenGL3dModel is updated to Jun623.

  (modification) Jun3dPolygon is updated to Jun628.  ACCURACY is
  derived from JunGeometry.

  (modification) Jun3dGraphicsContext is updated to Jun627.

  (modification) JunCursors is updated to Jun620.  Mouse cursors
  are added.

  (modification) JunOpenGLProjector and JunOpenGLProjection are
  updated to Jun618.

  (modification) JunBulletinBoard is updated to Jun629.

  (bug fix) Fixed a bug of JunTrackerModel.  Might not stop if a
  step is too small.

  (bug fix) Fixed a bug of JunOpenGL3dModel.  Might cause a
  deadlock with threads synchronization.

  (modification) JunOpenGLIllusion is updated to Jun655. 
  Illusion of a face mask is implemented.

  (modification) JunOpenGLFluxModel is updated to Jun632.  The
  number of frames per second can be specified.

  (modification) Jun3dCircle is updated to Jun610.  Some
  constructors are added.

  (modification) JunGeometry and its subclasses are updated to
  Jun610.  The methods equal_(Object) and equals(Object) are
  defined and printing/storing methods are refined.

Released version 609,  October 4, 2006

  (incompatibility) According to the modification of StPL8.0, the
  methods related to the old menu framework, which was deprecated
  since StPL7.0, was eliminated.

  (modification) JunOpenGLDisplayController is updated to Jun624. 
  Uses 'do_forMilliseconds_(StBlockClosure, int)' for the
  movement process.

  (new feature) Jun2dTriangle/Jun3dTriangle has some methods for
  dividing a triangle with a bisector (line/plane).  You can use
  these methods for dividing a 3D body or a 2D plane.  Please
  refer to the following URL for more information (only written
  in Japanese though): 
  http://www.sra.co.jp/people/aoki/Jun/Topics/DividingBody/index.html

  (new feature) JunControlUtility is introduced which provides
  some utility methods for controlling an execution of a task.

Released version 607,  September 12, 2006

  (new feature) Jun2dPolyline and Jun3dPolyline are implemented. 
  Its triangulation function with Constrained Delaunay
  Triangulation can be used to create a plane from a polyline. 
  Please refer to the following URL for more information  (only
  written in Japanese though): 
  http://www.sra.co.jp/people/aoki/Jun/Topics/TriangulationOfPolyline/index.html

  (bug fix) JunOpenGLRenderingContext is updated to Jun604. 
  Fixed a bug of the method:
  productTransformation_while_(Jun3dTransformation, StBlockClosure)

  (incompatibility) Refactoring on the DXF package done on Jun603. 
  The package 'jp.co.sra.jun.dxf.*' are moved to
  'jp.co.sra.jun.dxf.support.*'.

  (modification) JunStringUtility is updated to Jun599.

  (modification) JunLauncher is updated to Jun592.

  (modification) JunOpaqueImageIcons is updated to Jun591.  More
  opaque image icons are added.

  (new feature) JunOpenGLDisplayObjects is a display model which
  has a list of display objects to show.

  (modification) Jun3dTransformation/Jun2dTransformation are
  updated to Jun586.  More typical transformations.

  (modification) JunDisplayModel is updated to Jun580.

  (modification) JunImageStream is updated to Jun580.

  (modification) JunOpenGL3dModel and JunOpenGLDisplayModel are
  updated to Jun580.

Released version 579,  July 19, 2006

  (new feature) A new framework for superimposing on
  JunOpenGL3dModel is introduced.  You can draw anything with a
  Graphics of a JunOpenGL3dView.

  (new feature) JunImageBorderDecorator is a class to make an
  image be with a border decoration.

  (incompatibility) Refactoring on the packages done on Jun574. 
  The package 'jp.co.sra.jun.goodies.images.*' is renamed to
  'jp.co.sra.jun.goodies.image.*' and the classes in the package
  'jp.co.sra.jun.goodies.movie.*' are moved to
  'jp.co.sra.jun.goodies.movie.framework.*'.

  (modification) JunCartoonMovie is updated to Jun578.

  (modification) JunImagesToMovie is updated to Jun573.

Released version 568,  May 1, 2006

  (modification) The JNI libraries are updated for Intel Mac.

  (bug fix) Fixed some bugs of JunMoviePlayer.

  (bug fix) Fixed a bug of JunOpenGLRotationModel.  The lisp
  representation of an initial grid value is different from the
  one of the Smalltalk version.

  (incompatibility) Modified to be consistent.  A method named
  'asImage()' always returns StImage and a method named 'toImage()'
  always returns java.awt.Image now.

  (new feature) JunImageDisplayModel is a display model
  specifically for an image.

  (modification) JunImageUtility#writeImage_to_(Image, File) and
  other methods are implemented as utility methods for handling
  images.

  (modification) JunApplicationModel#saveAsImage() is added as a
  method to save a view of the application as an image.

  (new feature) JunGrapher is a class to give you a user
  interface for handling a graph:
    http://www.sra.co.jp/smalltalk/jun/Topics/Graph/index.html
    http://www.sra.co.jp/smalltalk/jun/Topics/ConcentricArranging/index.html

  (new feature) The package 'jp.co.sra.jun.topology.graph.*'
  contains some classes which represents general graph elements
  including graph, node and arc.

  (new feature) The package 'jp.co.sra.jun.goodies.tables.*'
  contains some classes which represent tables including a
  general attribute table, an adjacency table and an adjacency
  matrix.

  (new feature) JunSpiroDesign is a class to create and animate
  spiro graphs.  It can generate a snapshot image of a view and
  images of an animation:
    http://www.sra.co.jp/smalltalk/jun/Topics/SpiroDesign/index.html

Released version 551,  March 30, 2006

  (modification) One more hierarchy is introduced to classify the
  test submenu of JunLauncher.

  (modification) JunPen and JunPlotter are updated to Jun629.

  (new feature) JunSoroban is a class to give you a GUI of
  soroban (Japanese abacus) for handling beads by mouse.  You can
  copy & paste the number with the clipboard.

Released version 547,  February 24, 2006

  (new feature) JunMovieThumbnails is a class to capture
  specified frame images from a movie file and generate an html
  page for them.

  (new feature) Defines a speaker button with
  JunButtonWithMenuModel in JunTrackerModel and uses it in
  JunMoviePlayer.

  (new feature) JunButtonWithMenuModel is a subclass of
  JunButtonModel which shows a popup menu right next to the
  button.

  (modification) JunButtonController is updated to Jun540.

Released version 536b,  February 15, 2006

  (modification) JunOpenGLDisplayModel is updated to Jun550.

  (modification) JunOpenGLDisplayController is updated to Jun549.

  (modification) More cursors in JunCursors. Currently 87 in
  total.

Released version 536a,  November 30, 2005

  (modification) JunCursors is updated to Jun551.  Currently 66
  cursors are defined in total.

  (modification) Accessig methods to wheels of JunOpenGLShowModel
  are changed to be public.

  (modification) Refactoring on JunDrawing.

Released version 536,  October 28, 2005

  (new feature) JunOpenGLRoughSketch is a class which allows user
  to draw a simple closed curve and shows it as a plane in 3D
  space.

  (new feature) JunFormTriangulation2 is a class to compute a
  Constrained Delaunay Triangulation of a simple closed curve.

  (modification) More cursors in JunCursors.  Currently 59 in
  total.

  (incompatibility) jp.co.sra.jun.solid.abstracts.JunSolid is
  renamed to JunSolidModel since Jun533.

Released version 527a,  October 7, 2005

  (bug fix) Fix a bug of JunDrawing which causes OutOfMemoryError
  when a drawing area is too large.

Released version 527,  September 7, 2005

  (new feature) JunMultiMediaExtraModel is a class for
  JunMultiMediaViewer which handles any files besides images,
  movies, sounds, and texts.

  (modification) Override getInputContext() method of
  JunMovieViewAwt to suppress the following exception when
  closing:
      java.lang.IllegalStateException: Can't dispose InputContext while it's active

  (bug fix) JunMoviePlayer was confusing if its view has a
  tracker or not.

  (modification) Basically do nothing on a view if the view is
  not showing.

Released version 516a,  Auguest 19, 2005

  (modification) The default view mode is changed to SWING with
  the system look and feel.

  (modification) JunImageStream now supports "Java Image I/O" and
  use it as defaults.  JAI and JIMI might only be used to write
  BMP files on J2SDK1.4.

  (modification) All of the variables named 'enum' are renamed to
  'enumeration'.

Released version 516,  July 11, 2005

  (new feature) JunFileLauncher is a utility class which launches
  a file by selecting from a file dialog.  The application to
  launch a file is depending on your environment.

  (modification) JunFileDialog is updated to Jun513.  When
  requesting a directory and selecting a file or an unexisting
  directory, a warning message is shown, and now the
  file/directory name shown in the text field is cleared.

  (modification) JunOpenGL3dObject and JunOpenGLDisplayModel are
  updated to Jun511.  The methods to open a window by specifying
  a projection information are added.

  (modification) JunDisplayModel is updated to Jun511.  The
  methods to open a window by specifying a location or an area
  are added.

  (bug fix) The surface of JunChartPie was inside-out.

Released version 509,  June 10, 2005

  (modification) Adapt to the modified menu framework introduced
  in StPL7.1.

  (new feature) JunTextEditor is a class for editing a text and
  behaves as a value model, JunTextEditorDialog shows a dialog
  for editing a text with JunTextEditor.

Released version 500,  March 25, 2005

  (modification) JunOpenGLEmbeddedDisplayModel is modified not to
  send the 'displayObject' method to itself within the
  'setDisplayObject_(JunOpenGL3dObject)' method to avoid a
  potential infinite method call.  This will be modified Jun for
  Smalltalk (Jun625), too.

  (modification) Define $String static methods in some classes for
  convenience, which answer a string depending on current locale
  and message catalogs.

Released version 500rc5,  March 18, 2005

Released version 500rc4,  March 16, 2005

  (bug fix) JunCursors was supposed to cache its images and
  cursors.

  (new feature) Use the new multi-language framework introduced
  in StPL7.0.

  (bug fix) Unable to create an empty JunOpenGLFluxModel.

  (modification) On Linux, you can now render in double buffer
  mode by disabling a stencil buffer explicitly.  You can't
  change a visual of a Java created window, which has 0 bit
  stencil, anyway.

Released version 500rc3,  March 7, 2005

  (modification) Some of the JunLispCons constructor are added
  for convenience.

  (modification) On Mac OS X, use Cocoa instead of Carbon since
  we don't support J2SE 1.3 anymore.

  (modification) When opening JunTestExamples in Swing view mode,
  use JunDisplayViewSwing to show logo instead of JunDisplayViewAwt.

  (modification) Use the new menu framework introduced in StPL7.0.

Released version 500rc2,  February 18, 2005

  (incompatibility) The JNI library names are changed.  The
  OpenGL interface "jun4java" is renamed to "JunGL" and the
  QuickTime interface "JunQT4Java" is now just "JunQT".

Released version 500rc1,  February 16, 2005

  (incompatibility) The package name is changed from 'sra.*' to
  'jp.co.sra.*'.

Released version 499a,  February 9, 2005

  (new feature) You can choose 'QuickTime for Java' to handle
  multimedia besides our own JNI library.  The default on Mac OS
  X is 'QuickTime for Java'.

  (incompatibility) The initial/default projection settings of
  JunOpenGL3dModel is changed.

  (modification) JunOpenGL3dModel is modified to use the
  StApplicationModel#postOpenWith_(StView) framework, which is
  introduced in StPL(7.0), for setting the initial projection.

  (incompatibility) No more 'Java 2 Platform, Standard Edition,
  1.3' support.

Released version 499,  January 18, 2005

  (incompatibility) The methods of JunOpenGL3dObject,
  flushAllAlpha, flushAllName, flushAllPaint, are renamed to
  flushAllAlphas, flushAllNames, flushAllPaints, respectively.

  (bug fix) Fixed a bug of JunOpenGL3dTransformedObject and
  updated to Jun608.  Lights did not transformed appropriately.

  (modification) StViewJPanel#setLightWeightPopupEnabled(boolean)
  is used to create whether a heavy weight menu.

  (modification) JunQTInterface#canGetMovieFile() is implemented.

  (modification) A type of ProjectionTable of JunOpenGL3dModel is
  changed from Hashtable to Map.

  (new feature) JunOpenGL3dObject#yourselfAndNormalVectorsObject()
  is implemented.

  (modification) Refactoring on JunPoint.  Some of the return
  values and the method parameters are changed from
  Jun3dPoint/Jun2dPoint to JunPoint.

  (modification) SwingOnly mode becomes effective again.

  (bug fix) Fixed a bug of JunVrmlSFImageField.  An image was
  read upside down.

  (new feature) sra.jun.geometry.support.JunPointSorter is added,
  which sorts arbitrary 2D/3D vertexes based on the eye point and
  the up vector.

  (bug fix) Fixed a bug of
  Jun3dLine#intersectingPointWithLine_(Jun3dLine).

  (modification) JunOpenGL3dPatchedObject is modified (a) to be
  able to specify a normal vector and a color for each vertexes,
  (b) to keep a polygon's attributes when transformed, (c) to fix
  a bug which ignores a texture when reading from VRML, and (d)
  to choose the last ones if a color and/or a normal vector for
  each vertexes is not specified when writing to VRML.

  (new feature) Some utility method for displaying
  JunOpenGL3dObject are implemented.  You can specify a
  projection and a window place when showing JunOpenGL3dObject.

  (new feature) JunPlane now has the following methods:
    intersectingPointWithPlane_withPlane_(JunPlane, JunPlane)
    intersentingLineWithPlane_(JunPlane)

  (bug fix) JunOpenGL3dPolygon did not handle a halftone
  appropriately.

  (modification) Establish normal vectors when applying mirror
  transformation, which is modified on Jun604.

  (bug fix) JunOpenGL3dCone failed to create a cone on X-Z plane
  toward negative Y.

  (new feature) sra.jun.geometry.support.JunBSplineFunction is
  added and JunNurbsCurve#atT_(double) is implemented.

  (new feature) JunOpenGL3dNurbsCurve and JunOpenGL3dNurbsSurface
  are now able to read from / write to LST file.

  (modification) Refactoring on sra.jun.opengl.grapher.*.

Released version 498,  November 8, 2004

  (modification) JunPrologScanner is modified to handle dollar
  sign character just as a symbol.

  (modification) JunApplicationModel#updateMenus() is modified to
  do nothing if there is no window opened by the model.

  (new feature) The VRML97 parser is enhanced to handle multiple
  Viewport nodes as preset projections of JunOpenGL3dModel.

  (new feature) Multiple projections can be set to
  JunOpenGL3dModel as presets and they can be selected from
  "Preset" submenu of "View" menu.

  (modification) JunMovieHandle now takes care whether
  JunMovieHandleWithMovieController is used or not.

  (new feature) The VRML97 parser is enhanced to handle skyColor
  field of Background node as background color of JunOpenGL3dModel.

Released version 482b,  October 25, 2004

  (incompatibility) The geometry package 'sra.jun.geometry.*' are
  almost updated to Jun582.  As a result, (1) Jun3dBoundingBox is
  moved  from sra.jun.geometry.basic to
  sra.jun.geometry.boundaries, and  (2) JunPolygon is renamed to
  Jun3dPolygon.

  (incompatibility) JunPerspective is renamed to
  JunPerspectiveProjection.

  (incompatibility) JunOpenGLDisplayModelWithCamera is not needed
  anymore because JunOpenGLDisplayModel already have a function
  to save its view as an image.

  (modification) JunOpenGL3dViewSwing#render(Graphics) was needed
  to be removed because (1) it flickered in Double Buffer
  rendering, and (2) it showed unrelated images when there was no
  3D object.  JunOpenGL3dViewAwt was OK, but also removed.

  (new feature) The background color can be specified to
  JunOpenGL3dModel.

Released version 482a,  October 12, 2004

  (modification) JunButtonController is modified to create a
  thread for its repeat action only when needed.

  (modification) JunApplicationModel#openAt_(Point) is
  implemented.

Released version 482,  October 2, 2004

  (modification) Support Java 2 Platform Standard Edition 5.0.

  (new feature) Some polyhedra inscribed in a unit sphere are
  added as typical objects to JunOpenGL3dObject class.

  (new feature) A static method to create a sphere as a
  polyhedron with regular triangles is added to JunOpenGL3dObject
  class.

Released version 454c,  September 28, 2004

  (new feature) JunOpenGLIllusion is a class which generates some
  flux objects showing optical illusions.

  (new feature) JunAbstractView and JunAbstractController are
  introduced.

  (modification) Support Java 1.4.2 Update1 on Mac OS X 10.3.5.

Released version 454b,  September 3, 2004

  (new feature) Some more typical objects are added to
  JunOpenGL3dObject class.

  (modification) The "computeIntervals_divisionSize_(int, int)"
  of JunImageAdjuster is needed to be in public.

  (bug fix) Mask image of arrow cursor in JunCursors is fixed.

  (new feature) Image stream classes which handle GIF are added.

Released version 454a,  July 27, 2004

  (modification) Refinements of comments and formatting on some
  classes.

Released version 454,  June 21, 2004

  (bug fix) Some of the menu indications of JunOpenGLDisplayModel
  were not updated.

  (modification) JunOpenGLTexture is updated to Jun435.

  (new feature) JunOpenGL3dPatchedObject is a subclass of
  JunOpenGL3dCompoundObject which handles a patched body.

  (new feature) JunColorBarModel is a class for selecting a color
  from a range of colors with a bar-style user interface, and
  JunColorBarDialog shows a dialog to request a color with
  JunColorBarModel.

  (bug fix) JunUnion is updated to Jun450.  NullPointerException
  is now checked.

  (modification) JunScreenRecorder is updated to Jun448.  It now
  shows a progress with a stop button when creating a movie file.

  (modification) Jun3dTransformation#AlignVector_to_(Jun3dPoint,
  Jun3dPoint) is implemented.

  (modification) JunOpenGL3dObject#showWithUnitAxes() is a
  utility method to show the object with a unit axes.

  (modification) The constructor of JunOpenGL3dObject with a lisp
  list is introduced and the static method
  'FromLispList_(JunLispList)' is deprecated now.

  (modification) JunOpenGL3dCompoundObject is now holds its
  components as an ArrayList and does not create an array for
  caching.  Many constructors are also introduced and the
  static methods for instance creation are deprecated.

  (bug fix) JunDXFScanner is fixed to handle all kinds of line
  separators.

Released version 445,  April 15, 2004

  (new feature) JunGaugeModel is a class for specifying a value
  with a gauge by a mouse or arrow keys, and JunGaugeDialog shows
  a dialog to request a value with JunGaugeModel.

  (modification) JunFileModel now uses glob-style pattern
  matching to judge a file type.

  (modification) JunFreehandNote and JunFreehandPage now uses
  JunNibChoiceWithColorDialog to select a nib.

  (new feature) The package 'sra.jun.goodies.nib.*' contains
  several classes which allow you to select a nib.

  (modification) The stipple pattern of JunOpenGL3dPolyline class
  is now able to be specified with 'halftone_(double)' method.

  (modification) JunOpenGL3dModel computeZoomHeight() now
  calculate the zoom height not only with selected objects but
  all objects.

  (bug fix) The hot spot of JunCursors#NormalCursor() was wrong.

  (bug fix) The focus button image of JunOctreeEditModel was
  wrong.

  (bug fix) JunTerrainEditModel did not allow to cancel a peek
  creation.

  (modification) The exclusive buttons on JunOpenGLDisplayModel
  class and JunOpenGLMicrocosmModel class are stored in a HasMap.

  (modification) JunOpenGL3dModel class now has a method to set
  display lights.

  (modification) JunSystem now uses StMessageCatalog class, which
  is introduced in StPL6.5, for multi-language support.

  (bug fix) JunMovieHandlerWithMovieController failed to play in
  loop mode.

Released version 441,  March 16, 2004

  (new feature) JunOpenGLFluxModel is updated to Jun490 and can
  generate images and/or movie.

  (new feature) Support multi languages.  Window titles, menu
  labels, dialog messages are displayed in the language of the
  specified (or default) locale if the message catalog properties
  file of the locale is provided.  The message catalog properties
  file currently provided is Japanese only.

  (modification) JunFontModel not only shows all font families
  but shows all fonts.

  (modification) StDialog is replaced with JunDialog.

  (bug fix) Fixed some minor bugs in sra.jun.goodies.calendar.*.

  (new feature) JunImagesToMovie is a class which generates a
  QuickTime movie file from a series of image files.

Released version 431,  February 20, 2004

  (modification) The QuickTime interface is modified to support
  Java 2 SDK 1.4.2 on Mac OS X.

  (modification) JunMoviePlayer and JunMultiMediaViewer are
  modified according to a new key event handling framework
  introduced in StPL(6.3).

  (new feature) JunCartoonMovie is a class which plays images
  just like a movie.  It also can generate QuickTime move from
  the images.

  (modification) The popup menu of JunMovieViewSwing is changed
  to a heavyweight one.

  (modification) JunMultiMediaTextViewSwing is modified to show a
  top-left corner when initialized.

  (modification) JunOpenGLPlotter is modified not to use a
  deprecated method, Thread.stop().

  (new feature) JunOpaqueImageIcons is a class which provides
  some icon images created as StOpaqueImage.

  (new feature) JunImageProcessor now has some Juicing methods.

  (new feature) JunEmbeddedDisplayModel is a subclass of
  JunDisplayModel and introduced to be used as a display model
  embedded in other applications.  JunFontModel now uses
  JunEmbeddedDisplayModel instead of JunDisplayModel.

Released version 421,  January 9, 2004

  (modification) The QuickTime interface is modified to support
  Java 2 SDK 1.4.1 on Mac OS X.

  (incompatibility) sra.jun.opengl.microcosm.* is moved to
  sra.jun.opengl.cosmos.*

  (new feature) JunOpenGLHypercosmModel is a class which combines
  multiple JunOpenGLmacrocosmModel.
  http://www.sra.co.jp/people/nisinaka/Jun4Java/News/421/Hypercosm.mov

  (new feature) JunOpenGLMacrocosmModel is a class which creates
  and shows a 3D shape to view another 3D space.

  (modification) Some more typical objects are added to
  JunOpenGL3dObject.

  (modification) JunOpenGLRenderingContext implements Cloneable.

  (modification) polygonsDo_(StBlockClosure) is implemented in
  JunOpenGL3dObject and its subclasses.

Released version 406c,  December 19, 2003

  (new feature) JunMovieHandleWithMovieController is a class to
  play a movie using a movie controller provided by QuickTime. 
  Now the movie handle of the JunMoviePlayer is replaced with
  this.

  (modification) The new cursors, checkOnCursor and
  checkOffCursor, are added to JunCursors.

  (new feature) The package 'sra.jun.goodies.itemlist.*' contains
  several classes which allow you to list items, change order of
  the items, and make choices of the items interactively.

  (modification) JunStringUtility._ContractTo_(String, int)
  method will shorten a string with ellipsis if it is too long.

  (bug fix) The "Perspective" menu item of the ViewFinder called
  a wrong method in JunOpenGL3dModel.  Thanks Rob.

  (bug fix) JunSimpleSliderController & JunTrackSliderController
  kept Graphics and drew a slider in a bad place when resizing a
  window.

  (modification) Some more methods about rotation and production
  were added to Jun2dTransformation & Jun3dTransformation.

  (bug fix) JunCorsors.LeftArrowCursorImage() returned a wrong
  image.

  (bug fix) The static variables of Color with capital letters,
  which are introduced in Java2 SDK 1.4, were used by mistake.

Released version 406b,  October 28, 2003

  (new feature) JunVrmlPointSetNode is implemented.  It can
  parse PointSet node of VRML97 and convert to a composition of
  JunOpenGL3dVertex.

  (bug fix) The lights of JunOpenGLRenderingContext were not
  correctly cleared.

  (bug fix) When closing a window of StView opened from
  StApplicationModel, the StView was not removed from the
  dependents list of the StApplicationModel.

  (incompatibility) According to the modification of StPL(6.0),
  the subclasses of StApplicationModel are needed to be modified. 
  The closeRequest() method will generate an event
  WindowEvent.WINDOW_CLOSING.  As a result, windowClosing()
  method of StUIBuilder will be executed, and then
  noticeOfWindowClose() method of StApplicationModel will be
  called.  The windowClosing() method of StApplicationModel was
  renamed with noticeofWindowClose() method because it was not a
  callback method of WindowListener.

  (new feature) The package 'sra.jun.goodies.calendar.*'
  contains several classes which allow you to select date and/or
  time interactively.

Released version 406a,  October 21, 2003

  (bug fix) Wrong version of JunQT4Java JNI library (1.1 build 8)
  was included in the distribution package.  Replaced it with
  the correct one (1.1 build 9).

Released version 406,  October 3, 2003

  (new feature) JunOpenGL3dObject#asImage() is implemented.

  (bug fix) On some platforms, mostly Linux, if the OpenGL (or
  Mesa) only have visuals that can support double buffering,
  selecting rendering mode other than "Double Buffer" caused an
  unexpected exception in JNI library.

  (modification) JunLispInterpreter is updated to Jun490.

  (bug fix) On some platforms, mostly Linux, java.awt.Choice
  generates unnecessary events and JunFileViewAwt could be
  chattered.

  (bug fix) A workaround for a problem with Java2 SDK 1.3.1 &
  1.4.1 on Linux.  If a window contains a TextField, the dialog
  is tried to doLayout() with its size (0, 0) when the peer of
  the TextField is created and addNotify() of the TextField is
  called.  As a result, the content of the window would be
  resized to be fit on a window which size is (0, 0).

  (new feature) JunVrmlTextNode and JunVrmlFontStyleNode is
  implemented.  They can parse Text node and FontStyle node of
  VRML97, but not be converted into 3D objects.

  (bug fix) In a case that a JunOpenGL3dComposedObject contains
  both Opaque objects and Transparent objects, you had to care
  about the order of the primitive objects to do a correct alpha
  blending.  Now JunOpenGL3dComposedObject is modified and
  always render Opaque objects first.

  (new feature) Jun2dBoundingBox#intersectingPointsWithLine_(Jun2dLine)
  is implemented.

  (new feature) Jun2dLine#angleWithLine_(Jun2dLine) is
  implemented.

  (incompatibility) The 'ImageFromFile_()' method and
  'ImageFromFileDialog()' method of JunImageProcessor class now
  return StImage object instead of Image object.  You can get
  Image object by sending 'image()' method to StImage object.

  (new feature) The VRML97 parser is enhanced to handle color
  field and normal field of IndexedFaceSet node.

  (new feature) JunOpenGL3dPolygon is enhanced and now you can
  specify a color and a normal vector to each vertex.  By this
  enhancement, you can show a 3D object with Gouraud Shading.

  (bug fix) The order of transformation matrices applying to a
  3D object when parsing Transformation node of VRML97 was wrong.

  (new feature) JunMoviePlayer now can shows a sound meter by
  selecting "Sound meter" menu item from the popup menu. 
  JunMoviePlayer also can shows a slider which changes a sound
  volume by selecting "Sound volume" menu item from the popup
  menu.

  (new feature) JunSoundMeterModel is a class which shows a sound
  wave and a sound level.

  (new feature) JunSimpleGaugeModel is a combination of
  JunSimpleSliderModel and a pane which shows the current value
  of the JunSimpleSliderModel.

  (new feature) JunSimpleSliderModel is a class which shows a
  slider and allows users easily enter a numeric value.  This is
  quite similar to JunTrackSliderModel, but rather a simple one.

Released version 392c,  July 2, 2003

  (modification) The VRML97 parser/generator are modified to
  read/write a sight point information to avatarSize field of
  NavigationInfo node, following the enhancement of Cortona VRML
  Client.

Released version 392b,  July 1, 2003

  (new feature) The VRML97 parser is enhanced to handle
  emissiveColor field of Material node.

  (new feature) The VRML97 parser/generator are enchanced to
  handle projection information.

Released version 392a,  June 23, 2003

  (bug fix) Shell script files in bin directory and Makefiles in
  src-jni directory have wrong EOL, CRLF, instead of LF in the
  previous release.

Released version 392,  June 10, 2003

  (new feature) JunMillisecondModel is a class for specifying a
  time (hours, minutes, seconds, and milliseconds) with GUI and
  JunMillisecondDialog shows a dialog of JunMillisecondModel.

  (new feature) JunDialog is enhanced to open a dialog that
  requests users for input a line of text.

  (new feature) JunVisualCatalog is a class to create thumbnail
  images from a set of image/movie files and generate HTML files
  for browsing them.

Released version 379c,  May 16, 2003

  (bug fix) When stopping JunMoviePlayer, make sure to terminate
  its tracking process.  Otherwise an unexpected access violation
  in QuickTime.qts could be happend.

  (modification) JunOpenGL3dModel & JunOpenGLDisplayModel are
  updated to Jun493.

  (modification) JunOpenGL3dView & JunOpenGLDisplayView are
  updated to Jun475.

  (modification) JunShowModel is updated to Jun490.

  (modification) The layout manager 'WindowSpecLayout' is finally
  instroduced in StPL and now used for some views.

  (incompatibility) sra.jun.goodies.lisp.JunLispSmallCompiler is
  moved and renamed to sra.jun.system.support.JunSmallCompiler to
  be shared with classes other than JunLispInterpreter.

  (new feature) "Lisp" menu item and "Prolog" menu item are added
  to "Tools" menu of the launcher.  Each of them will open a
  dialog and there you can evaluate any statements of Lisp/Prolog.

Released version 379b,  May 6, 2003

  (modification) The "All" menu item is eliminated from each
  TestExamples classes of "Examples" -> "Test" menu of
  JunLauncher.  Instead "Spawn" menu item is added to open a
  TestExamples launcher.

  (bug fix) JunPrologInterpreter is reimplemented.

Released version 379a,  April 16, 2003

  (modification) Eliminated unnecessary import statements.

  (documentation) Renewed the home page.

  (modification) Refactoring of sra.jun.goodies.colors.  Separate
  JunColorChoiceDialog from JunColorChoiceModel as a subclass of
  StSimpleDialog, and updated equivalent to Jun490

Released version 379,  March 27, 2003

  (modification) JunApplicationModel now has a framework for
  handling KeyEvent.  All you need to do is overriding
  _keyListener() method which returns an appropriate KeyListener.

  (modification) JunMoviePlayer is updated to Jun490 except sound
  features.

  (modification) JunLauncher is enhanced.  (1) You can choose a
  Look&Feel (e.g. Metal, CDE/Motif, Windows, etc.) in Swing view
  mode, (2) You can specify a view mode and/or a rendering mode
  as command line arguments, and (3) JunJLauncher is eliminated
  since you can specify the Swing version of JunLauncher with a
  command line argument.

  (modification) JunTrackSliderModel and JunTrackerModel are
  updated to Jun472.

  (new feature) JunMultiMediaViewer is a class to see a content
  of a multi-media file.  You can browse your file system with
  JunFileModel and select a multi-media file that you want to see.

  (modification) JunDisplayModel shows its view on a scroll pane. 
  For backward compatibility, you can specify not to show
  scrolbars.

  (new feature) JunDumpModel is a class to show a byte array (or
  a binary file) in Hexadecimal dump format.

  (new feature) JunDialog is a class that provides some utility
  method for showing a dialog to confirm or to warn.  This is a
  replacement of StDialog.

  (modification) According to a modification of StPL(5.1),
  StValued and StBlockValued interfaces are introduced and
  StBlockValue doesn't have to perform "value" when computeValue.

  (new feature) JunFileModel is a class for choosing a file or a
  directory and JunFileDialog shows a dialog of JunFileModel.
  You can specify choosing an existing file/directory or a new
  file/directory.  Furthermore, for AWT users, you can choose a
  directory. :-)

Released version 366c,  March 6, 2003

  (new feature) JunFontModel is a class for choosing a font and
  JunFontDialog shows a dialog of JunFontModel.

  (new feature) JunLauncher has new menu items to choose a
  Look&Feel of the Swing view mode.

Released version 366b,  January 21, 2003

  (bug fix) JunOpenGLDisplayController#stopMovementProcess()
  could be blocked when closing while rotating.

Released version 366a,  January 14, 2003

  (bug fix) Overriding 'getPreferredSize()' may hinder the size
  setting in 'buildComponent()' because it is referred when
  packing.  GLjCanvas and JunOpenGL3dViewAwt are modified.

  (modification) JunOpenGLEmbeddedDisplayModel now has its own
  view and controller.

  (bug fix) JunProgress was blocking the EventDispatchThread.

  (new feature) JunLauncher has a new menu item "Information" at
  "Help" menu.  It will show various information about the system.

Released version 366,  December 25, 2002

  (new feature) JunBulletinBoard is a class to show a message
  scrolling on a window from right to left.

  (new feature) JunMoviePlayer is enhanced to make a clip.  You
  can set first/last markers on a tracker and save the range as a
  QuickTime movie.

  (modification) According to a modification of StPL(5.0), all
  views are needed to be created with a model, and the model can
  be referred in its 'buildComponent()' method.

  (modification) According to a modification of StPL(5.0), all
  you need to do to show a popup menu is just defining 'popupMenu()'
  method in a view class.

  (incompatibility) Modified to use JAWT interface to get drawing
  surface for OpenGL and QuickTime.  As a result, there could be
  some problems if you use Java virtual machine of Java2 SDK
  environment.  In that case, use Java Runtime Environment.

  (incompatibility) JAR files contained in a distribution package
  is now compiled with Java 2 SDK 1.4.1_01, so you will have to
  recompile them if you need to run on JDK1.2.

Released version 357,  November 5, 2002

  (new feature) JunDoubleMatrix is enhanced to be able to choose
  LU decomposition method when calculating an inverse.

  (new feature) JunTrackSliderModel and JunTrackerModel are
  enhanced to have first/last markers.  JunOpenGLFluxModel and
  JunMoviePlayer are modified to use them, and they are now able
  to play/repeat a part of a content.

  (new feature) JunScreenRecorder is a class to generate
  QuickTime movies from an entire screen or a part of a screen.
  Please refer to the following URL for more information  (only
  written in Japanese though): 
  http://www.sra.co.jp/people/aoki/Jun/Topics/ScreenRecorder/index.html

  (bug fix) JunLispCons generated illegal strings for saving if
  they contained double quotes.

Released version 347,  August 12, 2002

  (new feature) DXF Reader and Viewer, which were originally
  written for Smalltalk by Dr. Brent Reeves, are ported to Java. 
  Please refer to the following URL for more information: 
  http://www.sra.co.jp/people/aoki/Jun/Topics/DXF/index.html

  (new feature) The sra.jun.goodies.freehand.* is a package for
  freehand drawings.

  (new feature) JunBorderGenerator class is enhanced to generate
  2D/3D objects from a text string, and some static methods
  (their names start with 'Text') are implemented in
  JunOpenGL3dObject class to generate 2D/3D text as typical
  objects.

  (reorganization) Format source files with Jalopy.

Released version 340,  April 26, 2002

  (new feature) JunTerrainEditModel and JunTerrainDisplayModel
  are classes to edit and display terrain fields.  Please refer
  to the following URL for more information: 
  http://www.sra.co.jp/people/aoki/Jun/Topics/Terrain/index_e.html

  (new feature) Jun2dDelaunayProcessor is a class to process
  Delaunay Triangulation.

  (new feature) JunURL is a class to open a system default
  browser and show a specified URL.

  (modification) According to a modification of StPL(4.0), all
  views only need to override 'defaultController()' method and
  their relations will automatically be made.

  (modification) According to a new feature of StPL(4.0), most
  of the windows will be shown at a mouse cursor point.

  (license) "Jun for Java" package is being published as an open
  source software under the terms of "The modified BSD license".

Released version 316b,  January 18, 2002

  (modification) JNI library loading mechanism is changed to
  allow newer build number.

  (bug fix) Memory leak in qtDrawMovieFrame method on Windows.

Released version 316a,  December 15, 2001

  (new feature) According to an enhancement of StPL(3.6), a menu
  item 'Misc->Texture->From user...' is finally added to
  JunOpenGLDisplayModel and JunOpenGLEmbeddedDisplayModel.  Now
  you can cut an image on your display and put it as a texture
  on a 3D object.

  (new feature) JunCursorAnimator is a class to show cursor
  animations.  Currently two kinds of cursor animations are
  available: ClockCursors is a wrist watch cursor which ticks
  and HandCursors is a hand cursor which counts with fingers.

  (incompatibility) We finally decided not to support JDK1.1
  anymore and use Java2 features.

Released version 316,  April 25, 2001

  (new feature) Multimedia, such as movies (*.mov, *.avi, etc.)
  and sounds (*.aiff, *.wav, etc.), are supported to handle on
  platforms where the QuickTime is available.

  (new feature) JunImageToAscii is a class to convert a JPEG
  image to an ASCII character graphics.  Please refer to the
  following URL for more information (only written in Japanese
  though): http://www.sra.co.jp/people/aoki/ImageToAscii/index.html

  (new feature) JunImageStream and its related classes are
  enhanced.  You are now able to handle BMP, JPEG, and PNG
  images as image streams.  Java Advanced Imaging (JAI) and/or
  Jimi (just in case :-) are required.

  (reorganization) The directory 'jsrc', which contained Swing
  specific Java source files, is now combined with the directory
  'src'.  We assume that Jun users who uses JDK1.1 are less
  common these days.

Released version 306,  April 24, 2000

  (new feature) VRML reader is enhanced.

  (new feature) Hidden-Line Rendering is supported as a new
  presentation in addition to Solid Rendering and See-Through
  Wireframe.

Released version 301,  February 25, 2000

  (new feature) Swing components can be used with Jun.  If you
  want to use Swing components to build Jun applications, you
  can choose either J2SE or a combination of JDK1.1 and Swing
  1.1.1.

  (new feature) New solid models in addition to B-reps: CSG,
  Metaball, and Octree.

  (new feature) Prolog interpreter is available.

  (new feature) Voronoi processor/diagram and Delaunay diagram
  are available.

Released version 250a,  November 22, 1999

  (new feature) Now runs on Macintosh, too.

Released version 250,  September 13, 1999

  (new feature) Now runs on both MS Windows and Linux.  On
  Linux, Mesa3.0 or higher is required.

  (incompatibility) OpenGL related classes now belong to an
  independent package, sra.gl4jun, and are somewhat renamed.

  (new feature) Off screen rendering is supported.  The result
  of rendering will be stored in a java.awt.Image.

  (new feature) 4 kinds of rendering (Single Buffer, Double
  Buffer, Direct, Image) are supported.  You can choose one from
  JunLauncher (Help -> Default Rendering Mode).

Released version 234,  Auguest 23, 1999

  (new feature) New display model, JunOpenGLMicrocosm, is added.
  This display model will put you in a virtual space (Microcosm)
  and allow you to see & walk around.  Please refer to the
  following URL for more information (only written in Japanese
  though): http://www.sra.co.jp/people/aoki/Jun/Topics/Microcosm/index.html

  (new feature) Focus button is added to the Viewfinder.  This
  button allows you to select a focus area by click-and-drag the
  mouse on a viewfinder, and zoom to the focus area when you
  release the mouse button.

  (modification) JunOpenGLDisplayModel/View/Controller are
  refined to be more efficient.

  (modification) Some minor modifications to JunPolygon.  It now
  handles its points indirectly with a parameter polygon.

Released version 200,  July 7, 1999

  (incompatibility) Lot's of modifications for adapting to the
  new MVC framework (preparing for JavaBeans!!).

  (incompatibility) Lot's of modifications according to the
  elimination of some StPL classes.

  (new feature) Linear approx., clamp, and modulation can be
  specified for texture.

  (new feature) Line smoothing and polygon smoothing can be
  specified for rendering.

Released version 197,  May 13, 1999

  (new feature) MIPMAP can be specified for texture.

  (new feature) Lighting model has been changed.  Now you can
  use four kind of lights: Prallel light, Point light, Spot
  light, and Amibient Light.

Released version 187b,  April 30, 1999

  (modification) Some of the buttons, especially dolly button,
  are now look-alike for the ones of "Jun for Smalltalk."

  (modification) The size of Viewfinder/Viewport is now equal to
  "Jun for Smalltalk."

  (modification) Try to use java.awt.Image as much as possible,
  not to depend on sra.smalltalk.StImage.

  (modification) Try to use java.awt.Color as much as possible,
  not to depend on sra.smalltalk.StColorValue.

  (bugfix) Forgot to flush the buffered writer when generating 
  a lisp list with JunLispCons.

Released version 187a,  April 21, 1999
